unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, TATools, TASeries, TASources, Forms,
  Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, TACustomSource, Types;

type

  { TForm1 }

  TDataPoint = record x,y: Double; end;

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    Chart1LineSeries2: TLineSeries;
    ChartToolset1: TChartToolset;
    Label1: TLabel;
    Label2: TLabel;
    LineExtenderTool: TDataPointDragTool;
    CurveMoverTool: TDataPointHintTool;
    Panel1: TPanel;
    UserDefinedChartSource2: TUserDefinedChartSource;
    procedure CurveMoverToolAfterMouseDown(ATool: TChartTool; APoint: TPoint);
    procedure CurveMoverToolAfterMouseMove(ATool: TChartTool; APoint: TPoint);
    procedure FormCreate(Sender: TObject);
    procedure LineExtenderToolAfterMouseDown(ATool: TChartTool; APoint: TPoint);
    procedure LineExtenderToolAfterMouseMove(ATool: TChartTool; APoint: TPoint);
    procedure UserDefinedChartSource2GetChartDataItem(ASource: TUserDefinedChartSource;
      AIndex: Integer; var AItem: TChartDataItem);
  private
    { private declarations }
    CurveData: array of TDataPoint;
    XOffset: Double;
    YOffset: Double;
    FMouseDownPt: TPoint;
    FSlope: Double;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
const
  XMIN = 0;
  XMAX = 100;
var
  i: Integer;
  x,y: Double;
begin
  XOffset := 0;
  YOffset := 0;
  FMouseDownPt.X := MaxInt;
  FMouseDownPt.Y := MaxInt;

  // 1.Kurve (Gerade)
  for i:=0 to 1 do
  begin
    x := i * XMAX + XMIN;
    y := x;
    Chart1LineSeries1.AddXY(x, y);
  end;

  // 2.Kurve (Parabel)
  SetLength(CurveData, 100);
  for i:=0 to High(CurveData) do
  begin
    x := i/High(CurveData) * XMAX + XMIN;
    y := x*x*1e-2;
    CurveData[i].X := x;
    CurveData[i].Y := y;
  end;
  UserDefinedChartSource2.PointsNumber := Length(CurveData);
end;

procedure TForm1.LineExtenderToolAfterMouseDown(ATool: TChartTool;
  APoint: TPoint);
begin
  if TDataPointTool(ATool).Series <> Chart1LineSeries1 then
    exit;
  with Chart1LineSeries1 do
    FSlope := (YValue[1] - YValue[0]) / (XValue[1] - XValue[0]);
end;

procedure TForm1.LineExtenderToolAfterMouseMove(ATool: TChartTool;
  APoint: TPoint);
var
  x: Double;
begin
  x := Chart1.XImageToGraph(APoint.X);
  with Chart1LineSeries1 do
  begin
    XValue[1] := XValue[0] + FSlope * (x - XValue[0]);
    XValue[1] := x;
  end;
end;

procedure TForm1.CurveMoverToolAfterMouseDown(ATool: TChartTool; APoint: TPoint);
begin
  if TDataPointTool(ATool).Series <> Chart1Lineseries2 then
    exit;

  if FMouseDownPt.X = MaxInt then
    FMouseDownPt := APoint
  else
    FMouseDownPt.X := APoint.X - (Chart1.XGraphToImage(XOffset) - Chart1.XGraphToImage(0.0));
    FMouseDownPt.Y := APoint.Y - (Chart1.YGraphToImage(YOffset) - Chart1.YGraphToImage(0.0));
end;

procedure TForm1.CurveMoverToolAfterMouseMove(ATool: TChartTool; APoint: TPoint);
var
  dx: Double;
begin
  // Verschobene Distanz in Welt-Koordinaten umrechnen
  XOffset := Chart1.XImageTograph(APoint.X) - Chart1.XImageToGraph(FMouseDownPt.X);
  YOffset := Chart1.YImageTograph(APoint.Y) - Chart1.YImageToGraph(FMouseDownPt.Y);
  Chart1.Invalidate;
  Label2.Caption := Format('Verschiebung: %.3f', [XOffset]);
end;

procedure TForm1.UserDefinedChartSource2GetChartDataItem(
  ASource: TUserDefinedChartSource; AIndex: Integer; var AItem: TChartDataItem);
begin
  AItem.X := CurveData[AIndex].X + XOffset;
  AItem.Y := CurveData[AIndex].Y + YOffset;
end;

end.

